var linkedinDomain = 'https://www.linkedin.com';
$(async function(){
	var scraperTabs;
	var $startScrapingsButton = $('a#start_scraping');	
	$startScrapingsButton.click(async function(event){
		event.preventDefault();
		var $logItem = $('div#log');
		$logItem.text('');
		var csrfToken = await getCsrfToken();
		if (!csrfToken) {
			alert('Check if you are authorizated');
			return;
		}
		var buttonInnerText = $startScrapingsButton.text();
		$startScrapingsButton.text('Waiting...');		
		var start = 0;
		var monthsArr = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul","Aug", "Sep", "Oct", "Nov", "Dec" ];
        var profileId;
        var contactList = [];
		do{
            var url = linkedinDomain + '/voyager/api/relationships/dash/connections?count=40&decorationId=com.linkedin.voyager.dash.deco.web.mynetwork.ConnectionListWithProfile-5&q=search&sortType=RECENTLY_ADDED&start=' + start;
            var headers = { 'Accept': 'application/vnd.linkedin.normalized+json+2.1', 'Accept-Language': 'en-US,en;q=0.5', 
                  'x-li-track': '{"clientVersion":"1.6.8987","osName":"web","timezoneOffset":3,"deviceFormFactor":"DESKTOP","mpName":"voyager-web","displayDensity":1,"displayWidth":1920,"displayHeight":1080}',		
                  'x-li-lang': 'en_US', 'csrf-token': csrfToken, 'x-restli-protocol-version': '2.0.0' 
            };
            var connections = await getData(url, headers);
            var error = null;
            if (connections.status) {
                if (connections.status == '401') {
                	error = 'Check if you are logged';
                }
            } 
            if (!error && !connections.included) {
                error = 'Something is wrong';
            }
            if (error) {
            	alert('Error: ' + error);
            	$startScrapingsButton.text(buttonInnerText);
            	return;
            }
            for (var key in connections.included) {
                var contact = connections.included[key];
                profileId = contact.publicIdentifier;
                var profile = await findInStorage(profileId);
                if (profile) {
                	contactList[profileId] = profile;
                }else {
                    contactList[profileId] = {'name': contact.firstName + ' ' + contact.lastName, 'job_title': contact.headline, 'profile_url': linkedinDomain + '/in/' + profileId};
                    //var profileHtml = await getData(contactList[profileId]['profile_url'], headers);
                    //console.log(profileHtml);
                    //alert(333);
                    //return;                    
                    var contactInfo = await getData(linkedinDomain + '/voyager/api/identity/profiles/' + profileId + '/profileContactInfo', headers);
                    if (contactInfo.data.birthDateOn) {
                	    if (Object.keys(contactInfo.data.birthDateOn).length > 3) {
                		    console.log(contactInfo.data.birthDateOn);
                		    alert('date parts > 3: ' + profileId);
                		    return;
                	    }
                	    contactList[profileId].birthdate = contactInfo.data.birthDateOn.day + ' ' + monthsArr[contactInfo.data.birthDateOn.month - 1];   
                    }  
                    if (contactInfo.data.emailAddress) contactList[profileId].email = contactInfo.data.emailAddress;
       		        var phoneNumbers = [];
                    if (contactInfo.data.phoneNumbers && contactInfo.data.phoneNumbers.length) {
       		    	    for (var j in contactInfo.data.phoneNumbers) {
       		    		    phoneNumbers.push(contactInfo.data.phoneNumbers[j].type + ': ' + contactInfo.data.phoneNumbers[j].number);
       		    	    }     		    	
       		    	    contactList[profileId].phone = phoneNumbers.join(',');
      		        }
             	    var websites = [];
             	    if (contactInfo.data.websites && contactInfo.data.websites.length) {
             	    	for (var j in contactInfo.data.websites) {
             	    		websites.push(contactInfo.data.websites[j].url);
       		    	    }
             	    	contactList[profileId].website = websites.join(',');
             	    }
                    await saveInStorage(profileId, contactList[profileId]);
                }    
       		    $logItem.append(contactList[profileId].name + '<br/>');
            }
           start += 40;
		}while (connections.data.elements.length > 0);
		
		$startScrapingsButton.text(buttonInnerText);		
		SaveToCSV(contactList);
		$logItem.append('<h3>Please check download folder for export.</h3>');
		alert('Done');		
	});
		
	$("a#clear_storage").click(function(event){
		event.preventDefault();
		if (confirm('Are you sure?')) {
		    clearStorage();
		}
	});
});

function getCookie(name) {
	var cookies = document.cookie.split(';');
	for (var key in cookies) {
		var cookie = cookies[key].trim();
		if (cookie.indexOf(name + '=') == 0) {
			return cookie.substring(name.length + 1, cookie.length).trim();
		}
	}
	return false;
}

function setCookie(name, value) {
	let expirationDate = new Date(Date.now() + 3600 * 10 * 1000);
	expirationDate = expirationDate.toUTCString();
	document.cookie = name + '=' + value +'; path=/; expires=' + expirationDate;
}

function deleteCookie(name) {
	document.cookie = name + '=; path=/; expires=Thu, 01 Jan 1970 00:00:01 GMT';
}

function getCsrfToken() {
	return new Promise(function(resolve, reject) {
	    chrome.cookies.getAll({'url': linkedinDomain + '/', 'name': 'JSESSIONID'}, async function(cookieStores){
			if (cookieStores[0]) {
				resolve(cookieStores[0].value.replace(/"/g, '').trim());
			}else {
				resolve(null);
			}	        
		});
	});    
}

async function getData(url = '', headers = {}) {
	  const response = await fetch(url, {
	    method: 'GET', // *GET, POST, PUT, DELETE, etc.
	    mode: 'cors', // no-cors, *cors, same-origin
	    cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
	    credentials: 'same-origin', // include, *same-origin, omit
	    headers: headers,
	    redirect: 'follow', // manual, *follow, error
	    referrerPolicy: 'no-referrer' // no-referrer, *client
	  });
	  return await response.json(); // parses JSON response into native JavaScript objects
}

function saveInStorage(profileId, contactInfo) {
	return new Promise(function (resolve, reject){
		 var saveData = {};
		 saveData[profileId] = contactInfo;
		 chrome.storage.local.set(saveData, function() {
	         resolve(true);
	     });
	}) ;
}

function findInStorage(profileId) {
	return new Promise(function (resolve, reject){
		 chrome.storage.local.get(profileId, function(result) {
			 if (result[profileId]) {
	             resolve(result[profileId]);
			 }else {
				 resolve(null);
			 }
	     });
	});
}

function clearStorage() {
	chrome.storage.local.clear(function() {
	    var error = chrome.runtime.lastError;
	    if (error) {
	        console.error(error);
	    }else {
			alert('Cleared!');
	    }
	});
}

function SaveToCSV(contacts = []) {
	function padl2(s) { if(s<10) return '0'+s; return s; }
	var n = new Date();
	var filename = 'linkedin_'
        + '_' + n.getFullYear()+'-' + padl2(n.getMonth() + 1) +'-' + padl2(n.getDate())
		+ '_' + padl2(n.getHours())+'-' + padl2(n.getMinutes())+'-' + padl2(n.getSeconds())
        + '.csv';
	var separator = "\t", EOL = "\r\n";
	var data = '"Name"'+separator+'"Job Title"'+separator+'"Date Of Birth"'+separator+'"Email"'+separator+'"Phone Numbers"' + separator + '"Websites"' + separator+'"LinkedIn Profile URL"'+ EOL;

	var row;
	for (var key in contacts) {
		row = [contacts[key].name, contacts[key].job_title, contacts[key].birthdate?contacts[key].birthdate:'', contacts[key].email?contacts[key].email:'', contacts[key].phone?contacts[key].phone:'', contacts[key].website?contacts[key].website:'', contacts[key].profile_url];
	    for (var j in row) {
	    	row[j] = '"' + row[j].replace(/"/g, '').replace("\t", ' ') + '"';
	    }	
	    data += row.join(separator) + EOL;
	}

	var blob = new Blob([data], { type: 'text/csv;charset=utf-8;' });
	
	if (navigator.msSaveBlob) { // IE 10+
		navigator.msSaveBlob(blob, filename);
	} else {
		var link = document.createElement("a");
		if (link.download !== undefined) { // feature detection
		  // Browsers that support HTML5 download attribute
		  var url = URL.createObjectURL(blob);
		  link.setAttribute("href", url);
		  link.setAttribute("download", filename);
		  link.style.visibility = 'hidden';
		  document.body.appendChild(link);
		  link.click();
		  document.body.removeChild(link);
		}
	}
}

